Code

t4011: illustrate "diff-index -p" on stat-dirty paths
[git.git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example:       git-rebase master~1 topic
25         A---B---C topic                   A'\''--B'\''--C'\'' topic
26        /                   -->           /
27   D---E---F---G master          D---E---F---G master
28 '
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
37 LF='
38 '
39 OK_TO_SKIP_PRE_REBASE=
40 RESOLVEMSG="
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
44 "
45 unset newbase
46 strategy=recursive
47 strategy_opts=
48 do_merge=
49 dotest="$GIT_DIR"/rebase-merge
50 prec=4
51 verbose=
52 diffstat=$(git config --bool rebase.stat)
53 git_am_opt=
54 rebase_root=
55 force_rebase=
56 allow_rerere_autoupdate=
58 continue_merge () {
59         test -n "$prev_head" || die "prev_head must be defined"
60         test -d "$dotest" || die "$dotest directory does not exist"
62         unmerged=$(git ls-files -u)
63         if test -n "$unmerged"
64         then
65                 echo "You still have unmerged paths in your index"
66                 echo "did you forget to use git add?"
67                 die "$RESOLVEMSG"
68         fi
70         cmt=`cat "$dotest/current"`
71         if ! git diff-index --quiet --ignore-submodules HEAD --
72         then
73                 if ! git commit --no-verify -C "$cmt"
74                 then
75                         echo "Commit failed, please do not call \"git commit\""
76                         echo "directly, but instead do one of the following: "
77                         die "$RESOLVEMSG"
78                 fi
79                 if test -z "$GIT_QUIET"
80                 then
81                         printf "Committed: %0${prec}d " $msgnum
82                 fi
83                 echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
84         else
85                 if test -z "$GIT_QUIET"
86                 then
87                         printf "Already applied: %0${prec}d " $msgnum
88                 fi
89         fi
90         test -z "$GIT_QUIET" &&
91         GIT_PAGER='' git log --format=%s -1 "$cmt"
93         prev_head=`git rev-parse HEAD^0`
94         # save the resulting commit so we can read-tree on it later
95         echo "$prev_head" > "$dotest/prev_head"
97         # onto the next patch:
98         msgnum=$(($msgnum + 1))
99         echo "$msgnum" >"$dotest/msgnum"
102 call_merge () {
103         cmt="$(cat "$dotest/cmt.$1")"
104         echo "$cmt" > "$dotest/current"
105         hd=$(git rev-parse --verify HEAD)
106         cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
107         msgnum=$(cat "$dotest/msgnum")
108         end=$(cat "$dotest/end")
109         eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
110         eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
111         export GITHEAD_$cmt GITHEAD_$hd
112         if test -n "$GIT_QUIET"
113         then
114                 GIT_MERGE_VERBOSITY=1 && export GIT_MERGE_VERBOSITY
115         fi
116         eval 'git-merge-$strategy' $strategy_opts '"$cmt^" -- "$hd" "$cmt"'
117         rv=$?
118         case "$rv" in
119         0)
120                 unset GITHEAD_$cmt GITHEAD_$hd
121                 return
122                 ;;
123         1)
124                 git rerere $allow_rerere_autoupdate
125                 die "$RESOLVEMSG"
126                 ;;
127         2)
128                 echo "Strategy: $rv $strategy failed, try another" 1>&2
129                 die "$RESOLVEMSG"
130                 ;;
131         *)
132                 die "Unknown exit code ($rv) from command:" \
133                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
134                 ;;
135         esac
138 move_to_original_branch () {
139         test -z "$head_name" &&
140                 head_name="$(cat "$dotest"/head-name)" &&
141                 onto="$(cat "$dotest"/onto)" &&
142                 orig_head="$(cat "$dotest"/orig-head)"
143         case "$head_name" in
144         refs/*)
145                 message="rebase finished: $head_name onto $onto"
146                 git update-ref -m "$message" \
147                         $head_name $(git rev-parse HEAD) $orig_head &&
148                 git symbolic-ref HEAD $head_name ||
149                 die "Could not move back to $head_name"
150                 ;;
151         esac
154 finish_rb_merge () {
155         move_to_original_branch
156         git notes copy --for-rewrite=rebase < "$dotest"/rewritten
157         if test -x "$GIT_DIR"/hooks/post-rewrite &&
158                 test -s "$dotest"/rewritten; then
159                 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
160         fi
161         rm -r "$dotest"
162         say All done.
165 is_interactive () {
166         while test $# != 0
167         do
168                 case "$1" in
169                         -i|--interactive)
170                                 interactive_rebase=explicit
171                                 break
172                         ;;
173                         -p|--preserve-merges)
174                                 interactive_rebase=implied
175                         ;;
176                 esac
177                 shift
178         done
180         if [ "$interactive_rebase" = implied ]; then
181                 GIT_EDITOR=:
182                 export GIT_EDITOR
183         fi
185         test -n "$interactive_rebase" || test -f "$dotest"/interactive
188 run_pre_rebase_hook () {
189         if test -z "$OK_TO_SKIP_PRE_REBASE" &&
190            test -x "$GIT_DIR/hooks/pre-rebase"
191         then
192                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
193                 die "The pre-rebase hook refused to rebase."
194         fi
197 test -f "$GIT_DIR"/rebase-apply/applying &&
198         die 'It looks like git-am is in progress. Cannot rebase.'
200 is_interactive "$@" && exec git-rebase--interactive "$@"
202 while test $# != 0
203 do
204         case "$1" in
205         --no-verify)
206                 OK_TO_SKIP_PRE_REBASE=yes
207                 ;;
208         --continue)
209                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
210                         die "No rebase in progress?"
212                 git update-index --ignore-submodules --refresh &&
213                 git diff-files --quiet --ignore-submodules || {
214                         echo "You must edit all merge conflicts and then"
215                         echo "mark them as resolved using git add"
216                         exit 1
217                 }
218                 if test -d "$dotest"
219                 then
220                         prev_head=$(cat "$dotest/prev_head")
221                         end=$(cat "$dotest/end")
222                         msgnum=$(cat "$dotest/msgnum")
223                         onto=$(cat "$dotest/onto")
224                         GIT_QUIET=$(cat "$dotest/quiet")
225                         continue_merge
226                         while test "$msgnum" -le "$end"
227                         do
228                                 call_merge "$msgnum"
229                                 continue_merge
230                         done
231                         finish_rb_merge
232                         exit
233                 fi
234                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
235                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
236                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
237                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
238                 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
239                 move_to_original_branch
240                 exit
241                 ;;
242         --skip)
243                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
244                         die "No rebase in progress?"
246                 git reset --hard HEAD || exit $?
247                 if test -d "$dotest"
248                 then
249                         git rerere clear
250                         prev_head=$(cat "$dotest/prev_head")
251                         end=$(cat "$dotest/end")
252                         msgnum=$(cat "$dotest/msgnum")
253                         msgnum=$(($msgnum + 1))
254                         onto=$(cat "$dotest/onto")
255                         GIT_QUIET=$(cat "$dotest/quiet")
256                         while test "$msgnum" -le "$end"
257                         do
258                                 call_merge "$msgnum"
259                                 continue_merge
260                         done
261                         finish_rb_merge
262                         exit
263                 fi
264                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
265                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
266                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
267                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
268                 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
269                 move_to_original_branch
270                 exit
271                 ;;
272         --abort)
273                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
274                         die "No rebase in progress?"
276                 git rerere clear
277                 if test -d "$dotest"
278                 then
279                         GIT_QUIET=$(cat "$dotest/quiet")
280                         move_to_original_branch
281                 else
282                         dotest="$GIT_DIR"/rebase-apply
283                         GIT_QUIET=$(cat "$dotest/quiet")
284                         move_to_original_branch
285                 fi
286                 git reset --hard $(cat "$dotest/orig-head")
287                 rm -r "$dotest"
288                 exit
289                 ;;
290         --onto)
291                 test 2 -le "$#" || usage
292                 newbase="$2"
293                 shift
294                 ;;
295         -M|-m|--m|--me|--mer|--merg|--merge)
296                 do_merge=t
297                 ;;
298         -X*|--strategy-option*)
299                 case "$#,$1" in
300                 1,-X|1,--strategy-option)
301                         usage ;;
302                 *,-X|*,--strategy-option)
303                         newopt="$2"
304                         shift ;;
305                 *,--strategy-option=*)
306                         newopt="$(expr " $1" : ' --strategy-option=\(.*\)')" ;;
307                 *,-X*)
308                         newopt="$(expr " $1" : ' -X\(.*\)')" ;;
309                 1,*)
310                         usage ;;
311                 esac
312                 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$newopt")"
313                 do_merge=t
314                 ;;
315         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
316                 --strateg=*|--strategy=*|\
317         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
318                 case "$#,$1" in
319                 *,*=*)
320                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
321                 1,*)
322                         usage ;;
323                 *)
324                         strategy="$2"
325                         shift ;;
326                 esac
327                 do_merge=t
328                 ;;
329         -n|--no-stat)
330                 diffstat=
331                 ;;
332         --stat)
333                 diffstat=t
334                 ;;
335         -v|--verbose)
336                 verbose=t
337                 diffstat=t
338                 GIT_QUIET=
339                 ;;
340         -q|--quiet)
341                 GIT_QUIET=t
342                 git_am_opt="$git_am_opt -q"
343                 verbose=
344                 diffstat=
345                 ;;
346         --whitespace=*)
347                 git_am_opt="$git_am_opt $1"
348                 case "$1" in
349                 --whitespace=fix|--whitespace=strip)
350                         force_rebase=t
351                         ;;
352                 esac
353                 ;;
354         --ignore-whitespace)
355                 git_am_opt="$git_am_opt $1"
356                 ;;
357         --committer-date-is-author-date|--ignore-date)
358                 git_am_opt="$git_am_opt $1"
359                 force_rebase=t
360                 ;;
361         -C*)
362                 git_am_opt="$git_am_opt $1"
363                 ;;
364         --root)
365                 rebase_root=t
366                 ;;
367         -f|--f|--fo|--for|--forc|--force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase|--no-ff)
368                 force_rebase=t
369                 ;;
370         --rerere-autoupdate|--no-rerere-autoupdate)
371                 allow_rerere_autoupdate="$1"
372                 ;;
373         -*)
374                 usage
375                 ;;
376         *)
377                 break
378                 ;;
379         esac
380         shift
381 done
382 test $# -gt 2 && usage
384 if test $# -eq 0 && test -z "$rebase_root"
385 then
386         test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
387         test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
388                 die 'A rebase is in progress, try --continue, --skip or --abort.'
389 fi
391 # Make sure we do not have $GIT_DIR/rebase-apply
392 if test -z "$do_merge"
393 then
394         if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
395         then
396                 rmdir "$GIT_DIR"/rebase-apply
397         else
398                 echo >&2 '
399 It seems that I cannot create a rebase-apply directory, and
400 I wonder if you are in the middle of patch application or another
401 rebase.  If that is not the case, please
402         rm -fr '"$GIT_DIR"'/rebase-apply
403 and run me again.  I am stopping in case you still have something
404 valuable there.'
405                 exit 1
406         fi
407 else
408         if test -d "$dotest"
409         then
410                 die "previous rebase directory $dotest still exists." \
411                         'Try git rebase (--continue | --abort | --skip)'
412         fi
413 fi
415 # The tree must be really really clean.
416 if ! git update-index --ignore-submodules --refresh > /dev/null; then
417         echo >&2 "cannot rebase: you have unstaged changes"
418         git diff-files --name-status -r --ignore-submodules -- >&2
419         exit 1
420 fi
421 diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
422 case "$diff" in
423 ?*)     echo >&2 "cannot rebase: your index contains uncommitted changes"
424         echo >&2 "$diff"
425         exit 1
426         ;;
427 esac
429 if test -z "$rebase_root"
430 then
431         # The upstream head must be given.  Make sure it is valid.
432         upstream_name="$1"
433         shift
434         upstream=`git rev-parse --verify "${upstream_name}^0"` ||
435         die "invalid upstream $upstream_name"
436         unset root_flag
437         upstream_arg="$upstream_name"
438 else
439         test -z "$newbase" && die "--root must be used with --onto"
440         unset upstream_name
441         unset upstream
442         root_flag="--root"
443         upstream_arg="$root_flag"
444 fi
446 # Make sure the branch to rebase onto is valid.
447 onto_name=${newbase-"$upstream_name"}
448 case "$onto_name" in
449 *...*)
450         if      left=${onto_name%...*} right=${onto_name#*...} &&
451                 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
452         then
453                 case "$onto" in
454                 ?*"$LF"?*)
455                         die "$onto_name: there are more than one merge bases"
456                         ;;
457                 '')
458                         die "$onto_name: there is no merge base"
459                         ;;
460                 esac
461         else
462                 die "$onto_name: there is no merge base"
463         fi
464         ;;
465 *)
466         onto=$(git rev-parse --verify "${onto_name}^0") || exit
467         ;;
468 esac
470 # If a hook exists, give it a chance to interrupt
471 run_pre_rebase_hook "$upstream_arg" "$@"
473 # If the branch to rebase is given, that is the branch we will rebase
474 # $branch_name -- branch being rebased, or HEAD (already detached)
475 # $orig_head -- commit object name of tip of the branch before rebasing
476 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
477 switch_to=
478 case "$#" in
479 1)
480         # Is it "rebase other $branchname" or "rebase other $commit"?
481         branch_name="$1"
482         switch_to="$1"
484         if git show-ref --verify --quiet -- "refs/heads/$1" &&
485            branch=$(git rev-parse -q --verify "refs/heads/$1")
486         then
487                 head_name="refs/heads/$1"
488         elif branch=$(git rev-parse -q --verify "$1")
489         then
490                 head_name="detached HEAD"
491         else
492                 usage
493         fi
494         ;;
495 *)
496         # Do not need to switch branches, we are already on it.
497         if branch_name=`git symbolic-ref -q HEAD`
498         then
499                 head_name=$branch_name
500                 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
501         else
502                 head_name="detached HEAD"
503                 branch_name=HEAD ;# detached
504         fi
505         branch=$(git rev-parse --verify "${branch_name}^0") || exit
506         ;;
507 esac
508 orig_head=$branch
510 # Now we are rebasing commits $upstream..$branch (or with --root,
511 # everything leading up to $branch) on top of $onto
513 # Check if we are already based on $onto with linear history,
514 # but this should be done only when upstream and onto are the same.
515 mb=$(git merge-base "$onto" "$branch")
516 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
517         # linear history?
518         ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
519 then
520         if test -z "$force_rebase"
521         then
522                 # Lazily switch to the target branch if needed...
523                 test -z "$switch_to" || git checkout "$switch_to"
524                 say "Current branch $branch_name is up to date."
525                 exit 0
526         else
527                 say "Current branch $branch_name is up to date, rebase forced."
528         fi
529 fi
531 # Detach HEAD and reset the tree
532 say "First, rewinding head to replay your work on top of it..."
533 git checkout -q "$onto^0" || die "could not detach HEAD"
534 git update-ref ORIG_HEAD $branch
536 if test -n "$diffstat"
537 then
538         if test -n "$verbose"
539         then
540                 echo "Changes from $mb to $onto:"
541         fi
542         # We want color (if set), but no pager
543         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
544 fi
546 # If the $onto is a proper descendant of the tip of the branch, then
547 # we just fast-forwarded.
548 if test "$mb" = "$branch"
549 then
550         say "Fast-forwarded $branch_name to $onto_name."
551         move_to_original_branch
552         exit 0
553 fi
555 if test -n "$rebase_root"
556 then
557         revisions="$onto..$orig_head"
558 else
559         revisions="$upstream..$orig_head"
560 fi
562 if test -z "$do_merge"
563 then
564         git format-patch -k --stdout --full-index --ignore-if-in-upstream \
565                 --src-prefix=a/ --dst-prefix=b/ \
566                 --no-renames $root_flag "$revisions" |
567         git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
568         move_to_original_branch
569         ret=$?
570         test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
571                 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
572                 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
573                 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
574                 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
575         exit $ret
576 fi
578 # start doing a rebase with git-merge
579 # this is rename-aware if the recursive (default) strategy is used
581 mkdir -p "$dotest"
582 echo "$onto" > "$dotest/onto"
583 echo "$onto_name" > "$dotest/onto_name"
584 prev_head=$orig_head
585 echo "$prev_head" > "$dotest/prev_head"
586 echo "$orig_head" > "$dotest/orig-head"
587 echo "$head_name" > "$dotest/head-name"
588 echo "$GIT_QUIET" > "$dotest/quiet"
590 msgnum=0
591 for cmt in `git rev-list --reverse --no-merges "$revisions"`
592 do
593         msgnum=$(($msgnum + 1))
594         echo "$cmt" > "$dotest/cmt.$msgnum"
595 done
597 echo 1 >"$dotest/msgnum"
598 echo $msgnum >"$dotest/end"
600 end=$msgnum
601 msgnum=1
603 while test "$msgnum" -le "$end"
604 do
605         call_merge "$msgnum"
606         continue_merge
607 done
609 finish_rb_merge